Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 452587 - [BUGFIX] CPU hotplug support for x86_64
Summary: [BUGFIX] CPU hotplug support for x86_64
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel
Version: 5.2
Hardware: All
OS: Linux
low
low
Target Milestone: rc
: ---
Assignee: Prarit Bhargava
QA Contact: Martin Jenner
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-06-23 22:04 UTC by Alok Kataria
Modified: 2008-07-01 19:29 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2008-07-01 19:29:58 UTC


Attachments (Terms of Use)
Support physical cpu hotplug for x86_64 (deleted)
2008-06-23 22:04 UTC, Alok Kataria
no flags Details | Diff
Fix paranoia about using BIOS quickboot mechanism. (deleted)
2008-06-23 22:05 UTC, Alok Kataria
no flags Details | Diff
fix "buggy BIOS check" when CPUs are hot removed (deleted)
2008-06-23 22:06 UTC, Alok Kataria
no flags Details | Diff

Description Alok Kataria 2008-06-23 22:04:00 UTC
Description of problem:

Physical hotplug support for x86_64 kernels is broken in RHEL 5.2
RHEL 5.2 kernel is missing some code in ACPI to support physical hot remove of
CPUs. Even though there is a eject object under sysfs, because of the missing
support the CPU cannot be physically hot-removed. 
Along with this there are couple of bug's which are triggered when CPU are
hot-removed and added back to the system. 


Version-Release number of selected component (if applicable):
RHEL 5.2

Attached are patches which help physical cpu hotplug on rhel 5.2 (2.6.18-92).
All of these are backport of patches from the mainline tree. The patch headers
have information regarding the original commit.

Info about patches : 
1. acpi-hotplug-support.patch : Implements acpi_map_lsapic() and
acpi_unmap_lsapic() to support physical cpu hotplug.
2. bios_quickboot-mechanism : Fix paranoia about using BIOS quickboot mechanism
3. buggy-bios-check.patch : fix "buggy BIOS check" when CPUs are hot removed

Please apply. 

Thanks,
Alok

Comment 1 Alok Kataria 2008-06-23 22:04:00 UTC
Created attachment 310080 [details]
Support physical cpu hotplug for x86_64

Comment 2 Alok Kataria 2008-06-23 22:05:41 UTC
Created attachment 310081 [details]
Fix paranoia about using BIOS quickboot mechanism.

Comment 3 Alok Kataria 2008-06-23 22:06:18 UTC
Created attachment 310082 [details]
fix "buggy BIOS check" when CPUs are hot removed

Comment 5 Prarit Bhargava 2008-06-27 12:07:45 UTC
Please be advised, that Bugzilla is not a support tool. It is an
Engineering and Community tool. So although all changes to Enterprise
Linux go through Bugzilla and Red Hat considers issues directly entered
into Bugzilla valuable feedback, there is no SLA around it.

If this is a production issue, please report it to your Red Hat Support contact.

Thank you.


Comment 6 Alok Kataria 2008-07-01 18:57:05 UTC
(In reply to comment #5)
> Please be advised, that Bugzilla is not a support tool. It is an
> Engineering and Community tool. So although all changes to Enterprise
> Linux go through Bugzilla and Red Hat considers issues directly entered
> into Bugzilla valuable feedback, there is no SLA around it.
> 

Hi Prarit,

This is a BUG in the current RHEL 5.2 kernel code. The code for physical ACPI
CPU-hotplug is missing in 2.6.18 and subsequently from the RHEL kernel.  It was
merged in the mainline tree in the 2.6.19 release cycle. This bug can be hit on
a native system too which supports physical CPU hot plug. 

I had already backported the patches so attached them with the report. 

Similarly the other two patches too fixes BUGS while hotplug and were accepted
in the mainline tree.  These bugs can be hit with logical hotplug as well, i.e.
while offline-online'ing a cpu.

Here is the commit info for the individual patches, please cherry pick these
patches for the RH kernels. 

1. ACPI hotplug support
73fea175303926055440c06bc8894f0c5c58afc8

2. BIOS quickboot
63d38198a0f57dca87e6cb79931c7bedbb7ab069

3. Buggy bios check
ba62b077871a5255e271f4fdae57167651839277

Thanks you,
Alok

> If this is a production issue, please report it to your Red Hat Support contact.
> 
> Thank you.
> 

Comment 7 Prarit Bhargava 2008-07-01 19:29:58 UTC
Hi Alok,

RHEL5 does not support CPU hotswap.  We do support CPU hotplug, but not physical
additions and removals.

Thanks,

P.


Note You need to log in before you can comment on or make changes to this bug.